/**
 * The Gruntfile contains a list of tasks to be run, similar to a Makefile.
 */
module.exports = function(grunt) {

    // Read the Bootstrap variables from a "config.json" file generated by the customise site
    function getBootstrapVars() {
        var lessConfig = grunt.file.readJSON("assets/config/bootstrap-config.json");
        var lessVariables = {};
        for (var varName in lessConfig.vars) {
            if (lessConfig.vars.hasOwnProperty(varName)) {
                lessVariables[varName.substr(1)] = lessConfig.vars[varName];
            }
        }
        return lessVariables;
    }

    // Project configuration.
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),
        less: {
            options: {
                strictMath: true
            },
            bootstrap: {
                options: {
                    modifyVars: getBootstrapVars()
                },
                files: {
                    "build/css/bootstrap.css": "assets/components/bootstrap/less/bootstrap.less",
                    "build/css/bootstrap-theme.css": "assets/components/bootstrap/less/theme.less"
                }
            },
            bootstrap_datetimepicker: {
                files: {
                    "build/css/bootstrap-datetimepicker.css": "assets/components/eonasdan-bootstrap-datetimepicker/src/less/bootstrap-datetimepicker-build.less"
                }
            },
            fontawesome: {
                files: {
                    "build/css/font-awesome.css": "assets/components/font-awesome/less/font-awesome.less"
                }
            },
            debconf: {
                files: {
                    "build/css/debconf.css": "assets/less/debconf.less"
                }
            }
        },
        bowercopy: {
            options: {
                srcPrefix: "assets/components",
                destPrefix: "build"
            },
            build: {
                files: [
                    {
                        "js/jquery.js": "jquery/dist/jquery.js",
                        "js/moment.js": "moment/moment.js",
                        "js/moment-en-gb.js": "moment/locale/en-gb.js",
                        "js/bootstrap.js": "bootstrap/dist/js/bootstrap.js",
                        "js/bootstrap-datetimepicker.js": "eonasdan-bootstrap-datetimepicker/src/js/bootstrap-datetimepicker.js",
                        "js/video.js": "video.js/dist/video.js",
                        "js/videojs-resolution-switcher.js": "videojs-resolution-switcher/lib/videojs-resolution-switcher.js"
                    },
                    {
                        "css/jquery-ui.css": "jquery-ui/themes/base/jquery-ui.css",
                        "css/video-js.css": "video.js/dist/video-js.css",
                        "css/videojs-resolution-switcher.css": "videojs-resolution-switcher/lib/videojs-resolution-switcher.css"
                    },
                    {
                        src: ["font-awesome/fonts/*"],
                        dest: "fonts"
                    },
                    {
                        src: ["jquery-ui/themes/base/images/*"],
                        dest: "images"
                    }
                ]
            }
        },
        copy: {
            bootstrap_variables: {
                files: [
                    {
                        "assets/components/eonasdan-bootstrap-datetimepicker/src/less/bootstrap/less/variables.less": "assets/components/bootstrap/less/variables.less"
                    }
                ]
            },
            scripts: {
                files: [
                    {
                        "build/js/debconf.js": "assets/js/debconf.js",
                        "build/js/main-volunteer.js": "volunteers/static/main-volunteer.js"
                    }
                ]
            },
            images: {
                files: [
                    {
                        expand: true,
                        cwd: "assets/images/",
                        src: "**",
                        dest: "static/img/"
                    },
                    {
                        expand: true,
                        cwd: "volunteers/static/img/",
                        src: "**",
                        dest: "static/img/"
                    },
                    {
                        expand: true,
                        cwd: "build/images/",
                        src: "**",
                        dest: "static/img/"
                    }
                ]
            },
            fonts: {
                files: [
                    {
                        expand: true,
                        cwd: "assets/fonts/",
                        src: "**",
                        dest: "static/fonts/"
                    },
                    {
                        expand: true,
                        cwd: "build/fonts/",
                        src: "**",
                        dest: "static/fonts/"
                    }
                ]
            },
            styles: {
                files: [
                    {
                        "build/css/webfonts.css": "assets/css/webfonts.css",
                        "build/css/debconf-volunteer.css": "volunteers/static/css/master.css"
                    }
                ]
            },
            swf: {
                files: [
                    {"static/swf/video-js.swf": "assets/video.js/dist/video-js.swf"}
                ]
            }
        },
        concat: {
            scripts: {
                options: {
                    separator: ";\n"
                },
                src: [
                    "build/js/jquery.js",
                    "build/js/moment.js",
                    "build/js/moment-en-gb.js",
                    "build/js/bootstrap.js",
                    "build/js/bootstrap-datetimepicker.js",
                    "build/js/video.js",
                    "build/js/videojs-resolution-switcher.js",
                    "build/js/debconf.js"
                ],
                dest: "build/debconf16.js"
            },
            volunteer_scripts: {
                options: {
                    separator: ";\n"
                },
                src: [
                    "build/js/jquery.js",
                    "build/js/jquery-ui.js",
                    "build/js/debconf.js",
                    "build/js/main-volunteer.js"
                ],
                dest: "build/debconf16-volunteer.js"
            },
            styles: {
                options: {
                    separator: "\n"
                },
                src: [
                    "build/css/webfonts.css",
                    "build/css/font-awesome.css",
                    "build/css/bootstrap.css",
                    "build/css/bootstrap-theme.css",
                    "build/css/bootstrap-datetimepicker.css",
                    "build/css/video-js.css",
                    "build/css/videojs-resolution-switcher.css",
                    "build/css/debconf.css"
                ],
                dest: "build/debconf16.css"
            },
            volunteer_styles: {
                options: {
                    separator: "\n"
                },
                src: [
                    "build/css/jquery-ui",
                    "build/css/debconf-volunteer.css"
                ],
                dest: "build/debconf16-volunteer.css"
            }
        },
        uglify: {
            options: {
                preserveComments: false,
                sourceMap: true
            },
            build: {
                files: {
                    "static/js/debconf16.min.js":  "build/debconf16.js",
                    "static/js/debconf16-volunteer.min.js": "build/debconf16-volunteer.js"
                }
            }
        },
        cssmin: {
            options: {
                keepSpecialComments: 0
            },
            build: {
                files: {
                    "static/css/debconf16.min.css": "build/debconf16.css",
                    "static/css/debconf16-volunteer.min.css": "build/debconf16-volunteer.css"
                }
            }
        },
        clean: {
            build: [
                "build"
            ],
            static: [
                "static/fonts/*",
                "static/img/*",
                "static/css/*",
                "static/js/*",
                "!static/css/.gitkeep",
                "!static/js/.gitkeep"
            ]
        }
    });

    // Load the plugin that provides the "uglify" task.
    grunt.loadNpmTasks("grunt-contrib-clean");
    grunt.loadNpmTasks("grunt-contrib-concat");
    grunt.loadNpmTasks("grunt-contrib-copy");
    grunt.loadNpmTasks("grunt-contrib-cssmin");
    grunt.loadNpmTasks("grunt-contrib-less");
    grunt.loadNpmTasks("grunt-contrib-uglify");
    grunt.loadNpmTasks("grunt-bowercopy");

    // Default task(s).
    grunt.registerTask("build", [
        "clean:build",
        "clean:static",
        "bowercopy:build",
        "less:bootstrap",
        "copy:bootstrap_variables",
        "less:bootstrap_datetimepicker",
        "less:fontawesome",
        "less:debconf",
        "copy:styles",
        "copy:scripts",
        "concat:scripts",
        "concat:volunteer_scripts",
        "concat:styles",
        "concat:volunteer_styles",
        "copy:images",
        "copy:fonts",
        "copy:swf",
        "uglify:build",
        "cssmin:build",
    ]);
    grunt.registerTask("default", ["build"]);

};
